<template>
  <div class="container">
    <h2>{{ cal_name }}</h2>
    <div class="grid-container">
      <div class="result">{{ resultScreenText }}</div>
      <div class="formula">{{ formulaScreenText }}</div>
      <div class="grid-item clear" @click="onClear()">C</div>
      <div class="grid-item multiply" @click="setOperator(' x ')">x</div>
      <div class="grid-item minus" id="clear" @click="setOperator(' - ')">
        -
      </div>
      <div class="grid-item plus" id="clear" @click="setOperator(' + ')">+</div>
      <div class="grid-item seven" id="clear" @click="setNumber('7')">7</div>
      <div class="grid-item eight" id="clear" @click="setNumber('8')">8</div>
      <div class="grid-item nine" id="clear" @click="setNumber('9')">9</div>
      <div class="grid-item four" @click="setNumber('4')">4</div>
      <div class="grid-item five" @click="setNumber('5')">5</div>
      <div class="grid-item six" @click="setNumber('6')">6</div>
      <div class="grid-item equal" @click="Computation()">=</div>
      <div class="grid-item one" @click="setNumber('1')">1</div>
      <div class="grid-item two" @click="setNumber('2')">2</div>
      <div class="grid-item three" @click="setNumber('3')">3</div>
      <div class="grid-item zero" @click="setNumber('0')">0</div>
      <div class="grid-item dot" @click="setOperator('.')">.</div>
    </div>
  </div>
</template>

<script>
import getResult from "../services/service";

export default {
  name: "Calculator",
  props: {
    cal_name: String,
  },
  data() {
    return {
      formulaScreenText: "0",
      resultScreenText: "0",
      historyList: [],
      clickEqual: false,
    };
  },
  methods: {
    setNumber(number) {
      if (this.clickEqual) {
        this.onClear();
      }
      if (this.formulaScreenText === "0") {
        this.formulaScreenText = number;
      } else {
        const Pre_last_text = this.formulaScreenText.slice(-4, -1);
        const last_text = this.formulaScreenText.slice(-1);
        if (
          last_text === "0" &&
          (Pre_last_text === " + " ||
            Pre_last_text === " - " ||
            Pre_last_text === " x ")
        ) {
          this.formulaScreenText = this.formulaScreenText.slice(0, -1) + number;
        } else {
          this.formulaScreenText += number;
        }
      }
    },
    setOperator(operator) {
      const last_text = this.formulaScreenText.slice(-3);
      const dot_last_text = this.formulaScreenText.slice(-1);
      if (last_text === " + " || last_text === " - " || last_text === " x ") {
        this.formulaScreenText = this.formulaScreenText.slice(0, -3) + operator;
      } else if (dot_last_text === ".") {
        this.formulaScreenText = this.formulaScreenText.slice(0, -1) + operator;
      } else {
        this.formulaScreenText += operator;
      }
      if (operator === ".") {
        const dot = this.formulaScreenText.split("");
        for (let i = dot.length - 1; i >= 0; i--) {
          if (dot[dot.length - 1] === "." && dot[i - 1] === ".") {
            this.formulaScreenText = this.formulaScreenText.slice(0, -1);
          }
          if (dot[i] === "+" || dot[i] === "-" || dot[i] === "x") {
            break;
          }
        }
      }
    },
    async Computation() {
      const date = new Date()
      let formula = this.formulaScreenText;
      let formula_loop = this.formulaScreenText.split("");
      for (let i = 0; i < formula_loop.length; i++) {
        formula = formula.replace(" + ", "%2B");
        formula = formula.replace(" x ", "*");
      }
      this.resultScreenText = await getResult(formula);

      let list = {};
      list = {
        name: this.$props.cal_name,
        result: this.resultScreenText,
        formula: this.formulaScreenText,
        date:
          date.getDate().toString() +
          "/" +
          date.getMonth().toString() +
          "/" +
          date.getFullYear().toString() +
          " - " +
          date.getHours().toString() +
          ":" +
          date.getMinutes().toString() +
          "." +
          date.getSeconds().toString(),
      };

      if (JSON.parse(localStorage.getItem("historyList"))) {
        this.historyList = JSON.parse(localStorage.getItem("historyList"));
        this.historyList.push(list);
      } else {
        this.historyList.push(list);
      }
      localStorage.setItem("historyList", JSON.stringify(this.historyList));
      this.$store.state.dataLocal = this.historyList;
      this.historyList = [];
      this.clickEqual = true;
    },
    onClear() {
      this.formulaScreenText = "0";
      this.resultScreenText = "0";
      this.clickEqual = false;
    },
  },
};
</script>

<style scoped>
.grid-container {
  display: grid;
  grid-template-columns: auto auto auto auto;
  grid-gap: 10px;
  background-color: white;
  padding: 10%;
  width: 78%;
  height: 100%;
  border-color: black;
  border-radius: 30px;
}

.grid-item {
  background-color: #a7d4fa;
  border: 1px solid #a7d4fa;
  padding: 10%;
  font-size: 2.5rem;
  /* font-weight: 300; */
  color: #707070;
  display: flex;
  justify-content: center;
  align-items: center;
  border-radius: 15px;
  /* Prevent copying text in web-page */
  -webkit-touch-callout: none;
  /* iOS Safari */
  -webkit-user-select: none;
  /* Safari */
  -khtml-user-select: none;
  /* Konqueror HTML */
  -moz-user-select: none;
  /* Old versions of Firefox */
  -ms-user-select: none;
  /* Internet Explorer/Edge */
  user-select: none;
  /* Non-prefixed version, currently supported by Chrome, Edge, Opera and Firefox */
  /* -------------------------------- */
}

.plus {
  grid-area: 3/4/5/5;
}

.equal {
  grid-area: 5/4/8/5;
}

.zero {
  grid-area: 7/1/8/3;
}

.grid-item:hover {
  background-color: #d6eaf8;
}

.grid-item:active {
  background-color: #85c1e9;
}

.result {
  overflow: auto;
  font-size: 50px;
  grid-area: 1/1/2/5;
  color: #707070;
  -ms-overflow-style: none;
  /* IE and Edge */
  scrollbar-width: none;
  /* Firefox */
}
.result::-webkit-scrollbar {
  display: none;
}

.formula {
  overflow: auto;
  white-space: nowrap;
  font-size: 30px;
  grid-area: 2/1/3/5;
  color: #707070;
  border-top: 1px solid #cbcbcb;
  -ms-overflow-style: none;
  /* IE and Edge */
  scrollbar-width: none;
  /* Firefox */
}
.formula::-webkit-scrollbar {
  display: none;
}

h2 {
  color: #707070;
  font-weight: 400;
}
</style>
